format compact; clear; close all; clc

%% Fetch data
csv_filename = 'signal_in.csv';
[y, t] = csv2mat(csv_filename);

%% Spectral analysis
n = 2^16;
[f, Y] = spectrum(t, y, n);

%% Plots
TFS = 15;
LW = 2;
LFS = 10;

figure
subplot(2,1,1)
plot(t, y(:,1), 'LineWidth', LW)
hold on
plot(t, y(:,2), 'LineWidth', LW)
grid on
title('Signl', 'FontSize', TFS)
xlabel('t [s]', 'FontSize', LFS)
ylabel('y(t) [V]', 'FontSize', LFS)
legend({'y_1(t)', 'y_2(t)', 'y_3(t)', 'y_4(t)'}, 'FontSize', LFS)
xaxis([min(t) max(t)])
ax = gca;
ax.FontSize = LFS;
hold off

subplot(2,1,2)
plot(f,Y(:,1), 'LineWidth', LW);
hold on
plot(f,Y(:,2), '--', 'LineWidth', LW);
set(gca, 'XScale', 'log');
grid on
title('Jednostrann amplitudov spektrum signlu', 'FontSize', TFS)
xlabel('f [Hz]', 'FontSize', LFS)
ylabel('|Y(f)| [dB]', 'FontSize', LFS)
legend({'Y_1(f)', 'Y_2(f)', 'Y_3(f)', 'Y_4(f)'}, 'FontSize', LFS)
xaxis([min(f) max(f)])
ax = gca;
ax.FontSize = LFS;
hold off